#!/usr/bin/perl

use Data::Dumper;
use CGI;
use CGI::Carp qw/ fatalsToBrowser /;
use XML::DOM;
use Digest::SHA1 qw(sha1_hex);

print "Content-type: text/html; charset=utf-8\n\n";

require("cfg_utils.pl");
require("config_xml.pl");
require("access.pl");
if (!ConnectionAllowed($ENV{"REMOTE_ADDR"}, $allowManagerConnect)) {
  print "Connection denied\n";
  exit;
}

my $cfg = loadConfig("Repository.xml");

if (!defined($cfg->{"man.user"})) {
  writehtpasswd("", ""); # just for sure
} else {
  config_checklogin({$cfg->{"man.user"} => $cfg->{"man.passwordHash"}});
}

my $writeback = 0;
my @errors;

# Ha van stub file, az elõzõ körbõl, vagy egy POST-data-ból, dolgozzuk fel.
my $stubFname = undef;
$_POST = new CGI;

if ($fh = $_POST->upload('xml_stub')) {
  $stubFname = "stub." . $ENV{"UNIQUE_ID"} . ".xml";
  open(TMPFILE, ">$stubFname");
  while ($line = <$fh>) {
    print TMPFILE $line;
  }
  close(TMPFILE);
} elsif (($_POST->param("stub")) && -e $_POST->param("stub")) {
  $stubFname = $_POST->param("stub");
}

if ($stubFname) {
  $stub = loadConfig($stubFname);
  $cfg = mergeArrays($cfg, $stub);
}

#print Dumper("<pre>", $_POST->param, $_POST, $cfg, "</pre>");
if($_POST->param('commence_cfg')) {
  #$_POSTd gyartasa
  my @_POSTparams = $_POST->param;
  for (my $i = 0; $i <= $#_POSTparams; $i++) {
    my $w = $_POSTparams[$i];
    my $r = $_POST->param($w);
    $_POSTd->{$1} = $r if ($w =~ m/^d[[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2}->{$3} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2}->{$3}->{$4} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2}->{$3}->{$4}->{$5} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2}->{$3}->{$4}->{$5}->{$6} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]]$/);
    $_POSTd->{$1}->{$2}->{$3}->{$4}->{$5}->{$6}->{$7} = $r if ($w =~ m/^d[[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]][[]([^]]+)[]]$/);
    #print "$i " . $w . " " . $r . "<br/>";
  }
  #print Dumper("<pre>", $_POSTd, "</pre>");
}

# un-magic_quote
foreach $key (keys %{$cfg->{"format"}}) {
  if($_POST->param('commence_cfg')) {
    #$_POSTd->{"format"}->{$key}->{"csvseparator"} =
  } else {
    $cfg->{"format"}->{$key}->{"csvseparator"} =~ s/\t/\\t/g;
  }
}

if($_POST->param('commence_cfg')) {
  $cfg = mergeArrays($cfg, $_POSTd);
  $writeback = 1;
}
$d = $cfg;

# Pofozzunk ki a  CSV mappingot.
foreach $fmtKey (keys %{$d->{"format"}}) {
  $format = $d->{"format"}->{$fmtKey};
  my $csv;
  my $rownum = 1;
  foreach $rowx (sort { $a <=> $b } keys %{$format->{"csv"}}) {
    $row = $format->{"csv"}->{$rowx};
    if (($row->{"del"} != 1) && ($row->{"tag"} ne "" || $row->{"attribute"} ne "")) {
      $csv->{$rownum} = $row;
      $rownum++;
    }
  }
  $d->{"format"}->{$fmtKey}->{"csv"} = $csv;
}

# A jelszó.
if ($d->{"man.passwd"} ne "") {
  if ($d->{"man.passwd"} ne $d->{"man.passwd2"}) {
    push @errors, '<span class="error">A két jelszó különbözik!<span>';
    $writeback = 0;
  } else {
    $d->{"man.passwordHash"} = sha1_hex($d->{"man.passwd"});
    push @errors, 'A jelszó megváltozott.';
  }
}

# A konfiguráció visszaírása.
if ($writeback) {
  $fname = "Repository.xml";
  open CONFFILE, ">" . $fname || die("Nem tudom megnyitni a konfigurációs fájlt! ($fname)");
  print CONFFILE confdata($d) || die("Hiba a konfigurációs file kiírásánál ($fname)");
  close CONFFILE || die("Nem tudom lezárni a konfigurációs fájlt! ($fname)");
  writehtpasswd($d->{"man.user"}, $d->{"man.passwordHash"});

  if ($stubFname) {
    unlink($stubFname);
    $stubFname = undef;
  }

  push @errors, "A konfigurációs file sikeresen elmentve.";
}

print <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2" />
<title>Config editor</title>
<link href="common.css" rel="stylesheet" type="text/css" />
<script language="JavaScript">
<!--

var __def_fn_equ_cmpre = new RegExp("^(d\\[format\\]\\[[0-9]+\\]\\[csv\\]\\[)[0-9]+(\\].*)$", "i");
/** Ez a changeInputs() függvény default fn_equ() függvénye. Azért ez a default,
 * mert ebben a formban minden helyzetben muködik. Igazából ezt a függvényt belel is drótozhattam volna a
 * changeInputs() függvénybe, de hátha jól jön még egy késobbi projektemben. (2004. 07. 07.)
 */
function _def_fn_equ(ffName, ffs) {
  var ffnr = ffName.match(__def_fn_equ_cmpre);
  var ffn2r;

  for(var i = 0; i < ffs.length; i++) {
    ffn2r = ffs[i].match(__def_fn_equ_cmpre);
    if(ffnr[1] == ffn2r[1] && ffnr[2] == ffn2r[2]) return ffs[i];
  }
  return null;
}

function _enumAllFormChilds(obj, arr) {
  var c = obj.childNodes;

  for(var i = 0; i < c.length; i++) {
    if(c[i].nodeName.toLowerCase() == 'input') {
      if(c[i].type.toLowerCase() == 'text' || c[i].type.toLowerCase() == 'hidden' || c[i].type.toLowerCase() == 'checkbox') arr[arr.length] = c[i].id;
    } else if(c[i].nodeName.toLowerCase() == 'select') arr[arr.length] = c[i].id;
    else if(c[i].hasChildNodes()) _enumAllFormChilds(c[i], arr);
  }
}

/** Ez a funkció összeszedi a htmlid1 és a htmlid2 ID-jú html tag-ek gyerekei közül a form mezoket, és
 * kicseréli a tartalmukat, az fn_equ függvény segítségével.
 *
 * Az fn_equ függvény egy két paraméteru függvény, az elso paraméter egy input mezo neve, a htmlid1 formmezo tipusú gyermekei közül, a másik egy array,
 * amiben a htmlid2-es összes formmezojének a neve van. Ebbol meg kell keresni, a névhez tartozó párt. Ha nem talál, null-lal kell visszatérnie.
 * (pl.: fn_equ('d_name1', Array('d_id2', 'd_name2', 'd_txt2')) - ekkor a függvény visszatérési értéke: 'd_name2').
 */
function changeInputs(htmlid1, htmlid2, fn_equ) {
  var o1, o2;
  var fa1 = Array();
  var fa2 = Array();

  o1 = document.getElementById(htmlid1);
  o2 = document.getElementById(htmlid2);

  if(typeof o1 == 'undefined' || typeof o2 == 'undefined' || o1 == null || o2 == null) return;

  _enumAllFormChilds(o1, fa1);
  _enumAllFormChilds(o2, fa2);

  if(typeof fn_equ == 'undefined') fn_equ = _def_fn_equ;
  for(var i = 0; i < fa1.length; i++) {
    var s = fn_equ(fa1[i], fa2);
//    alert(s + " --- " + fa1[i]);
    if(s == null) continue;
    o1 = document.getElementById(fa1[i]);
    o2 = document.getElementById(s);

    if(o1.nodeName.toLowerCase() == 'input') {
      if(o1.type.toLowerCase() == 'text' || o1.type.toLowerCase() == 'hidden') {
        var tmp = o1.value;
        o1.value = o2.value;
        o2.value = tmp;
      } else if(o1.type.toLowerCase() == 'checkbox') {
        var tmp = o1.checked;
        o1.checked = o2.checked;
        o2.checked = tmp;
      }
    } else if(o1.nodeName.toLowerCase() == 'select') {
      var tmp = o1.selectedIndex;
      o1.selectedIndex = o2.selectedIndex;
      o2.selectedIndex = tmp;
    }
  }
}

//-->
</script>
</head>
<body class="defbody">
<div class="admhead">Konfiguráció módosítása</div>
EOF
;

if ($#errors >= 0) {
  print '<center><div class="errorbox">';
  foreach $err (@errors) {
    print $err . "<br>";
  }
  print '</div></center>';
}

$x = <<EOF
<div class="admcontent">
 <form action="#" method="post" enctype="application/x-www-form-urlencoded" name="fcfg" id="fcfg" style="margin: 0px;">
  <div class="admboxhead">Adatbázis</div>
  <div class="admbox">
   <table border="0" align="center" cellpadding="1" cellspacing="1">
    <tr>
     <td align="right" class="defcell">Tipus:</td>
     <td class="defcell"><input name="d[db.type]" type="text" class="inp" id="d[db.type]" value="$d->{"db.type"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Host:</td>
     <td class="defcell"><input name="d[db.host]" type="text" class="inp" id="d[db.host]" value="$d->{"db.host"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Username:</td>
     <td class="defcell"><input name="d[db.username]" type="text" class="inp" id="d[db.username]" value="$d->{"db.username"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Password:</td>
     <td class="defcell"><input name="d[db.password]" type="text" class="inp" id="d[db.password]" value="$d->{"db.password"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Database:</td>
     <td class="defcell"><input name="d[db.database]" type="text" class="inp" id="d[db.database]" value="$d->{"db.database"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Table:</td>
     <td class="defcell"><input name="d[db.table]" type="text" class="inp" id="d[db.table]" value="$d->{"db.table"}" /></td>
    </tr>
   </table>
  </div>
  <div class="admboxhead">Beállítások/Azonosítás</div>
  <div class="admbox">
   <table border="0" align="center" cellpadding="1" cellspacing="1">
    <tr>
     <td align="right" class="defcell">Repository név: </td>
     <td class="defcell"><b>$d->{"id.repositoryName"}</b></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Repository ID: </td>
     <td class="defcell"><b>$d->{"id.repositoryId"}</b></td>
    </tr>
    <tr>
     <td align="right" class="defcell">URL:</td>
     <td class="defcell"><b>$d->{"id.baseURL"}</b></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Admin email:</td>
     <td class="defcell"><input name="d[id.email]" type="text" class="inp" id="d[id.email]" value="$d->{"id.email"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Törölt elemek:</td>
     <td class="defcell"><select name="d[id.del]" class="inp" id="d[id.del]">
EOF
;
$x .= '       <option value="persistent"';
$x .= ' selected="selected"' if ($d->{"id.del"} eq "persistent");
$x .= ">Végleges</option>\n";
$x .= '       <option value="no"';
$x .= ' selected="selected"' if ($d->{"id.del"} eq "no");
$x .= ">Nincs</option>\n";
$x .= '       <option value="transient"';
$x .= ' selected="selected"' if ($d->{"id.del"} eq "transient");
$x .= ">Ideiglenes</option>\n";
$x .= <<EOF
      </select>     </td>
    </tr>
    <tr>
     <td align="right" class="defcell">Resumption méret:</td>
     <td class="defcell"><input name="d[sett.res.size]" type="text" class="inp" id="d[sett.res.size]" value="$d->{"sett.res.size"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Resumption elévülés:</td>
     <td class="defcell"><input name="d[sett.res.exp]" type="text" class="inp" id="d[sett.res.exp]" value="$d->{"sett.res.exp"}" /></td>
    </tr>
   </table>
  </div>
  <div class="admboxhead">Változásjelentés</div>
  <div class="admbox">
   <table border="0" align="center" cellpadding="1" cellspacing="1">
    <tr>
     <td align="right">Változásjelentési URL:</td>
     <td>$d->{"mod.url"}</td>
    </tr>
    <tr>
     <td align="right">Azonosító paraméter neve:</td>
     <td>$d->{"mod.idParParam"}</td>
    </tr>
    <tr>
     <td align="right">Séma paraméter neve:</td>
     <td>$d->{"mod.schemaParName"}</td>
    </tr>
   </table>
  </div>
  <div class="admboxhead">Távoli hozzáférés</div>
  <div class="admbox">
   <table border="0" align="center" cellpadding="1" cellspacing="1">
    <tr>
     <td align="right" class="defcell">Felhasználónév:</td>
     <td class="defcell"><input name="d[man.user]" type="text" class="inp" id="d[man.user]" value="$d->{"man.user"}" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Jelszó:</td>
     <td class="defcell"><input name="d[man.passwd]" type="password" class="inp" id="d[man.passwd]" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Jelszó még egyszer: </td>
     <td class="defcell"><input name="d[man.passwd2]" type="password" class="inp" id="d[man.passwd2]" /></td>
    </tr>
   </table>
  </div>
  <div class="admboxhead">IP listák</div>
  <div class="admbox">
   <table border="0" align="center" cellpadding="1" cellspacing="1">
    <tr>
     <td align="right" class="defcell">Manager:</td>
     <td class="defcell"><input name="d[ip.manager]" type="text" class="inp" id="d[ip.manager]" value="$d->{"ip.manager"}" size="60" /></td>
    </tr>
    <tr>
     <td align="right" class="defcell">Harvester:</td>
     <td class="defcell"><input name="d[ip.harvester]" type="text" class="inp" id="d[ip.harvester]" value="$d->{"ip.harvester"}" size="60" /></td>
    </tr>
   </table>
  </div>
  <div class="admboxhead">CSV adatkonverziók </div>
  <div class="admbox">
EOF
;

$data = $x;

$j = 0;
foreach $key (sort { $a <=> $b } keys %{$d->{"format"}}) {
  $format = $d->{"format"}->{"$key"};
  if ($format->{"namespace"} eq 'http://www.openarchives.org/OAI/2.0/oai_dc/') { $j++; next; };
  my $x = "";
  $x = <<EOF
   <table border="0" align="center" cellpadding="0" cellspacing="0">
    <tr>
     <td align="left">
     <table border="0" cellpadding="1" cellspacing="1">
      <tr>
       <td align="right" class="defcell">NS prefix:</td>
       <td class="defcell"><b>$format->{"name"}</b></td>
      </tr>
      <tr>
       <td align="right" class="defcell">Namespace:</td>
       <td class="defcell"><b>$format->{"namespace"}</b></td>
      </tr>
      <tr>
       <td align="right" class="defcell">Schema URL: </td>
       <td class="defcell"><b>$format->{"schema"}</b></td>
      </tr>
      <tr>
       <td align="right" class="defcell">Gyökérelem:</td>
       <td class="defcell"><b>$format->{"rootElementName"}</b></td>
      </tr>
      <tr>
       <td align="right" class="defcell">Feltöltenõ csv file separator:</td>
       <td class="defcell"><input name="d[format][${j}][csvseparator]" type="text" class="inp" id="d[format][${j}][csvseparator]" value="$format->{"csvseparator"}" maxlength="2" /> ( \\t = TAB )</td>
      </tr>
     </table></td>
    </tr>
    <tr>
     <td><table border="0" cellspacing="1" cellpadding="1">
      <tr>
       <td class="defcell">#</td>
       <td class="defcell">DC elem</td>
       <td class="defcell">Qualifier</td>
       <td class="defcell">törlendõ</td>
       <td colspan="2" class="defcell">&nbsp;</td>
      </tr>
EOF
;
  my $csv = $format->{"csv"};
  $i = 0;
  # TODO:HACK
  $maxr = 0;
  foreach $rown (sort { $a <=> $b } keys %$csv) {
    $maxr = $rown;
  }
  $maxr += 3;
  #foreach $rown (sort { $a <=> $b } keys %$csv) {
  for ($rown = 1; $rown <= $maxr; $rown++) {
    $row = $csv->{$rown};
    $ip = $i + 1; $im = $i - 1;
    $x .= <<EOF
      <tr id="row${j}x${i}">
       <td class="defcell">${ip}.</td>
       <td class="defcell"><input name="d[format][${j}][csv][${i}][tag]" type="text" class="inp" id="d[format][${j}][csv][${i}][tag]" value="$row->{"tag"}" /></td>
       <td class="defcell"><input name="d[format][${j}][csv][${i}][attribute]" type="text" class="inp" id="d[format][${j}][csv][${i}][attribute]"  value="$row->{"attribute"}"/></td>
       <td align="center" class="defcell"><input name="d[format][${j}][csv][${i}][del]" type="checkbox" id="d[format][${j}][csv][${i}][del]" value="1" /></td>
       <td class="defcell">&nbsp;<a href="javascript:changeInputs('row${j}x${i}', 'row${j}x${im}')" class="lnk_a">föl</a>&nbsp;</td>
       <td class="defcell">&nbsp;<a href="javascript:changeInputs('row${j}x${i}', 'row${j}x${ip}')" class="lnk_a">le</a>&nbsp;</td>
      </tr>
EOF
;
    $i++;
  }
  $x .= <<EOF
     </table></td>
    </tr>
   </table>
   <div class="info">&nbsp;</div>
EOF
;
  $j++;
  $data .= $x;
}
$data .= <<EOF
  </div>
  <div class="admbox" style="margin-top: 15px;"><center><input name="commence_cfg" type="submit" class="butt" id="commence_cfg" value="Konfiguráció mentése" /></center>
EOF
;
if ($stubFname) {
  $data .= '<input name="stub" type="hidden" id="stub" value="' . $stubFname . '" />';
}

$data .= <<EOF
  </div>
 </form>
</div>
</body>
</html>
EOF
;

print $data;
