#!/usr/bin/perl

# .xml configuracio beolvaso (es a beolvasast segito) rutinok
# oai.pl hivja

use XML::DOM;
use Data::Dumper;

# az xml formatumu configuracios file
$XMLconfigfile = "Repository.xml";


# valtozasjelentes minimum ilyen idokozonkent tortenik (sec)
$triggerHarvesterInterval = 3600 * 12;



# a betoltes modja - nem mukodik (?)
$mode = 0; # 0 = minden alkalommal a teljes allomany kerul konvertalasra. ha valamely azonositoju rekord ebben nem szerepel,
           # torolt statuszt kap a repositoryban.
           # 1 = csak a valtozasok illetve az uj rekordok kerulnek beolvasasra. ekkor nem mukodik a torles.

# TODO:DC sema adatok - hacking, nem hozzanyulni!
# DC sema mar nincs hasznalatban
$oai_dc_semanev = "oai_dc";
$oai_dc_format = "dc";
$oai_dc_format_namespace = "http://purl.org/dc/elements/1.1/";
$oai_dc_xsd = "http://www.openarchives.org/OAI/2.0/oai_dc.xsd";
$oai_dc_namespace = "http://www.openarchives.org/OAI/2.0/oai_dc/";



sub getSubelementContent {
  my ($DomElement, $tagname, $num) = @_;
  if (defined($DomElement)) {
    @x = $DomElement->getElementsByTagName($tagname);
    if ($x[$num] && $x[$num]->getFirstChild()) { # $#x >= $num) {
      return $x[$num]->getFirstChild()->toString();
    }
  }
  return undef;
}

sub getConnectIPs {
  my ($dom, $tagname) = @_;

  my $allow;
  my @domallow = $dom->getElementsByTagName($tagname);
  if ($domallow[0]) {
    my @domHCip = ($dom->getElementsByTagName($tagname))[0]->getChildNodes;
    for my $kid (@domHCip) {
      if (($kid->getNodeType == ELEMENT_NODE) && ($kid->getTagName() eq "ip")) {
        $allow->{$kid->getFirstChild()->toString()} = $kid->getFirstChild()->toString();
      }
    }
  }
  return $allow;
}


# config, repository, metadataFormats, revmetadataFormats hashref-ek eloallitasa

my $parser = new XML::DOM::Parser;
my $dom = $parser->parsefile($XMLconfigfile) or die "Hiba a konfiguracio betoltese kozben( " . $XMLconfigfile . " )\n";

@domsettings = $dom->getElementsByTagName("settings");
$config->{"resumptionSize"} = getSubelementContent($domsettings[0], "resumptionSize");
$config->{"resumptionExpirationHours"} = getSubelementContent($domsettings[0], "resumptionExpirationHours");

@domidentification = $dom->getElementsByTagName("identification");
$config->{"repositoryName"} = getSubelementContent($domidentification[0], "repositoryName");
$config->{"repositoryId"} = getSubelementContent($domidentification[0], "repositoryId");
$config->{"baseURL"} = getSubelementContent($domidentification[0], "baseURL");
$config->{"protocolVersion"} = getSubelementContent($domidentification[0], "protocolVersion");
$config->{"deletedRecord"} = getSubelementContent($domidentification[0], "deletedRecord");
$config->{"adminEmail"} = getSubelementContent($domidentification[0], "adminEmail");
$i = 0;
while ($tmp = getSubelementContent($domidentification[0], "friends", $i)) {
  push @{$config->{"friends"}}, $tmp;
  $i++;
}

@dommodificationReport = $dom->getElementsByTagName("modificationReport");
$config->{"modificationReport.url"} = getSubelementContent($dommodificationReport[0], "url");
$config->{"modificationReport.identifierParamName"} = getSubelementContent($dommodificationReport[0], "identifierParamName");
$config->{"modificationReport.schemaListParamName"} = getSubelementContent($dommodificationReport[0], "schemaListParamName");
$config->{"modificationReport.mode"} = getSubelementContent($dommodificationReport[0], "mode");

@dommanager = ($dom->getElementsByTagName("repository"))[0]->getChildNodes;
for my $kid (@dommanager) {
  if (($kid->getNodeType == ELEMENT_NODE) && ($kid->getTagName() eq "manager")) {
    $manager->{getSubelementContent($kid, "user")} = getSubelementContent($kid, "passwordHash");
  }
}

@domdatabase = $dom->getElementsByTagName("database");
$repository->{"type"} = getSubelementContent($domdatabase[0], "type");
$repository->{"host"} = getSubelementContent($domdatabase[0], "host");
$repository->{"user"} = getSubelementContent($domdatabase[0], "username");
$repository->{"password"} = getSubelementContent($domdatabase[0], "password");
$repository->{"database"} = getSubelementContent($domdatabase[0], "database");
$repository->{"table"} = getSubelementContent($domdatabase[0], "table");
if (getSubelementContent($domdatabase[0], "warn") eq "1") {
  $repository->{"warn"} = 1;
} else {
  $repository->{"warn"} = 0;
}

@dommetadataFormats = $dom->getElementsByTagName("metadataFormats");
@domFormats = $dommetadataFormats[0]->getChildNodes();
for my $kid (@domFormats) {
  if (($kid->getNodeType == ELEMENT_NODE) && ($kid->getTagName() eq "format")) {
    my $format_name = $kid->getAttribute("name");
    my $rootElementName = getSubelementContent($kid, "rootElementName");

    @domcsvmap = $kid->getChildNodes();
    my $map, $dcmap, %$x, %$y;
    for my $csvmap (@domcsvmap) {
      if (($csvmap->getNodeType == ELEMENT_NODE) && ($csvmap->getTagName() eq "csvmap")) {
        $_column = $csvmap->getAttribute("column");
        $_tag = $csvmap->getAttribute("tag");
        $_attr = $csvmap->getAttribute("attribute");
        $map->[$_column]->[0] = $_tag;
        $map->[$_column]->[1] = $_attr;
        if (! ($x->{$_tag}->{$_attr})) {
          $x->{$_tag}->{$_attr} = 0;
        }
        $map->[$_column]->[2] = $x->{$_tag}->{$_attr};
        $x->{$_tag}->{$_attr}++;

        $dcmap->[$_column]->[0] = $_tag;
        if (! ($y->{$_tag})) {
          $y->{$_tag} = 0;
        }
        $dcmap->[$_column]->[1] = $y->{$_tag};
        $y->{$_tag}++;
      }
    }

    $metadataFormats->{$format_name}->{"map"} = $map;
    $metadataFormats->{$format_name}->{"dcmap"} = $dcmap;
    $revmetadataFormats->{$rootElementName}->{"map"} = $map;
    $revmetadataFormats->{$rootElementName}->{"dcmap"} = $dcmap;
    # just for sure
    undef %$x;
    undef %$y;
    undef $map;
    undef $dcmap;
    # a betltend llomnyban az rtkek elvlasztshoz hasznlt szepartor
    $metadataFormats->{$format_name}->{"csvseparator"} = getSubelementContent($kid, "csvseparator");
    $revmetadataFormats->{$rootElementName}->{"csvseparator"} = getSubelementContent($kid, "csvseparator");

    # metadata format for format.name -> rootElementName conversion
    $metadataFormats->{$format_name}->{"format.name"} = $format_name;
    $metadataFormats->{$format_name}->{"rootElementName"} = $rootElementName;
    $metadataFormats->{$format_name}->{"schema"} = getSubelementContent($kid, "schema");
    $metadataFormats->{$format_name}->{"namespace"} = getSubelementContent($kid, "namespace");
    # reverse metadata format for rootElementName -> format.name conversion
    $revmetadataFormats->{$rootElementName}->{"format.name"} = $format_name;
    $revmetadataFormats->{$rootElementName}->{"rootElementName"} = $rootElementName;
    $revmetadataFormats->{$rootElementName}->{"schema"} = getSubelementContent($kid, "schema");
    $revmetadataFormats->{$rootElementName}->{"namespace"} = getSubelementContent($kid, "namespace");
  }
}

$allowHarvesterConnect = getConnectIPs($dom, "allowHarvesterConnect");
$allowManagerConnect = getConnectIPs($dom, "allowManagerConnect");
#print Dumper($allowHarvesterConnect, $allowManagerConnect);

foreach my $key (keys(%$config)) {
  if (!defined($config->{$key})) {
    delete $config->{$key};
  }
}
#print Dumper('<pre>', $config, $repository, '</pre>');

return 1;
