#!/usr/bin/perl
#use strict;
use CGI;
use DBI;
use POSIX qw(tmpnam);
require("parameters_inc.pl");
require("oaicommon.pl");

my ($query, $debug, $g_title, $d_overwrite, $_FILES);

sub PrintHeader {
  print $query->start_html(
    -title => "$g_title",
    -link => "#ffff00",
    -vlink => "#00ffff",
    -alink => "#ffff00");
}

sub PrintForm {
  print "<center>\n";
  print '<h3>perl filefeltlts</h3>';
  print "<table border=0 cellpadding=5 cellspacing=0>\n";

  print $query->start_multipart_form, "\n";

  #------------- upload
  print "<tr>\n";
  print " <td align=\"right\">File feltltse:</td>\n";
  print " <td>\n";
  print $query->filefield(-name => 'userfile',
          -size => 50,
          -maxlength => 200);
  print " </td>\n";
  print "</tr>\n";
  #------------- submit
  for $key (sort keys %$metadataFormats) {
    if ($key ne "oai_dc") {
      push @values, $metadataFormats->{$key}->{"rootElementName"};
      $labels->{$metadataFormats->{$key}->{"rootElementName"}} = $key;
    }
  }
  my $defaultselect = $query->param('schema');
  print "<tr>\n";
  print " <td align=\"right\">Az albbi smba:</td>\n";
  print " <td>\n";
  print $query->popup_menu(
    -name => 'schema',
    -values => \@values,
    -default => $defaultselect,
    -labels => $labels);
  print " </td>\n";
  print "</tr>\n";
  # csv header
  my $csvheaderselected = $query->param("csvheader");
  print "<tr>\n";
  print " <td>\n";
  print " </td>\n";
  print " <td>\n";
  print $query->checkbox(-name => "csvheader",
    -checked => $csvheaderselected,
    -value => 1,
    -label => "a csv fjl fejlcet hasznl") , "\n";
  print " </td>\n";
  print "</tr>\n";
  #print " <td align=\"right\">a csv fjl fejlcet hasznl</td>\n";
  #print '<br /><input name="csvheader" type="checkbox" id="csvheader" value="0" ' . (isset($_REQUEST["csvheader"]) ? "checked" : "") . '">' . "\n";
  #print 'a csv fjl fejlcet hasznl</input>';

  # SUBMIT
  print "<tr>\n";
  print " <td colspan=2 align=\"center\">\n";
  print " <hr noshade size=1>\n";
  print $query->submit(-label => 'upload',
          -value => 'Feltlt'),"\n";
  print " </td>\n";
  print "</tr>\n";

  print $query->endform,"\n";

  print "</table>\n";
  print "</center>\n";
}

sub PrintFooter {
  print $query->end_html();
}

# oai_dc xml gyartasa
sub generateXML_oai_dc {
  my ($xml, $dc_schema, $dc_xsd, $dc_namespace, $dc_schema_format) = @_;
  $dc_xsd = "http://www.openarchives.org/OAI/2.0/oai_dc.xsd" if (!$dc_xsd);
  $dc_namespace = "http://www.openarchives.org/OAI/2.0/oai_dc/" if (!$dc_namespace);
  $dc_schema_format = "dc" if (!$dc_schema_format);

  $dc_schema = $revmetadataFormats->{$dc_schema_format}->{"format.name"};

  my $str = XMLtagStart($dc_schema . ":" . $dc_schema_format, {
    "xmlns:" . $dc_schema => $dc_namespace,
    " xsi:schemaLocation" => $dc_namespace . " " . $dc_xsd,
    "xmlns:" . $dc_schema_format => $oai_dc_format_namespace,
    "xmlns" => "http://www.openarchives.org/OAI/2.0/",
    "xmlns:xsi" => "http://www.w3.org/2001/XMLSchema-instance"});
  foreach my $kulcs (sort keys(%$xml)) {
    my $ertek = $xml->{$kulcs};
    foreach my $key (sort keys(%$ertek)) {
      my $val = $xml->{$kulcs}->{$key};
      foreach my $i (sort keys(%$val)) {
        if (length($xml->{$kulcs}->{$key}->{$i}) > 0) {
          if (($kulcs ne $key) && ($key ne "")) {
            $str .= XMLtag($dc_schema_format . ":" . $kulcs, array("qualifier" => $key), htmlspecialchars($xml->{$kulcs}->{$key}->{$i}));
          } else {
            $str .= XMLtag($dc_schema_format . ":" . $kulcs, undef, htmlspecialchars($xml->{$kulcs}->{$key}->{$i}));
          }
        }
      }
    }
  }
  $str .= XMLtagEnd($dc_schema . ":" . $dc_schema_format);
  return $str;
}

# generateXML
# a kapott paramterek alapjn felpti a DC kompatibilis XML llomnyt
sub generateXML {
  my ($xml, $betoltendo_semanev, $sema_xsd, $sema_namespace, $sema_format) = @_;
  $betoltendo_semanev = $revmetadataFormats->{$sema_format}->{"format.name"};
  my $str = XMLtagStart($betoltendo_semanev . ":" . $sema_format, {
    "xmlns:xsi" => "http://www.w3.org/2001/XMLSchema-instance",
    "xmlns:" . $betoltendo_semanev => $sema_namespace,
    "xsi:schemaLocation" => $sema_namespace . " ". $sema_xsd});

  foreach my $kulcs (sort keys(%$xml)) {
    my $ertek = $xml->{$kulcs};
    foreach my $key (sort keys(%$ertek)) {
      my $val = $xml->{$kulcs}->{$key};
      foreach my $i (sort keys(%$val)) {
        if (length($xml->{$kulcs}->{$key}->{$i}) > 0) {
          if (($kulcs ne $key) && ($key ne "")) {
            $str .= XMLtag($betoltendo_semanev . ":" . $kulcs, {"qualifier" => $key}, htmlspecialchars($xml->{$kulcs}->{$key}->{$i}));
          } else {
            $str .= XMLtag($betoltendo_semanev . ":" . $kulcs, undef, htmlspecialchars($xml->{$kulcs}->{$key}->{$i}));
          }
        }
      }
    }
  }
  $str .= XMLtagEnd($betoltendo_semanev . ":" . $sema_format);
  return $str;
}

# writeRecords
# betlts sorn feldolgozott, illetve a korbbiakban mr betlttt adatokkal sszefslt j repository
# allomany adatbazisba toltese
sub writeRecords {
  my ($repository, $records, $repositoryIdentifier) = @_;

  $db = new transdb($repository->{"type"}, $repository->{"host"}, $repository->{"user"}, $repository->{"password"}, $repository->{"database"});
  $sql = $db->delete($repository->{"table"}, "externalid <> ''");
  print "<table cellpadding=2 cellspacing=0 border=1><tr><td colspan=4 align=center>Osszes OAI rekord</td></tr>";
  print "<tr><td>kulso rekord azonosito</td><td>sema</td><td>kiosztott oai azonosito</td><td>statusz</td></tr>";

  foreach $id (sort { $a <=> $b } keys %$records) {
    foreach $semanev (sort keys %{$records->{$id}}) {
      #$records->{$id}->{$semanev}->{"id"} = $id;
      #$records->{$id}->{$semanev}->{"root_name"} = $semanev;
      $db->insert($repository->{"table"}, {
        "id" => $db->escapestr($records->{$id}->{$semanev}->{"id"}),
        "sett" => $db->escapestr($records->{$id}->{$semanev}->{"sett"}),
        "created" => $db->escapedate($records->{$id}->{$semanev}->{"created"}),
        "modified" => $db->escapedate($records->{$id}->{$semanev}->{"modified"}),
        "deleted" => $db->escapedate($records->{$id}->{$semanev}->{"deleted"}),
        "xml" => $db->escapestr($records->{$id}->{$semanev}->{"xml"}),
        "harvestable" => $db->escapestr($records->{$id}->{$semanev}->{"harvestable"}),
        "root_name" => $db->escapestr($records->{$id}->{$semanev}->{"root_name"}),
        "root_namespace" => $db->escapestr($records->{$id}->{$semanev}->{"root_namespace"}),
        "externalid" => $db->escapestr($records->{$id}->{$semanev}->{"externalid"})});
      print "<tr><td>" . $records->{$id}->{$semanev}->{"externalid"} . "</td><td>" . $semanev . "</td><td>oai:" . $repositoryIdentifier . ":" . $id . "</td>";
      if ($records->{$id}->{$semanev}->{"created"} ne $records->{$id}->{$semanev}->{"deleted"}) {
        print "<td>deleted</td>";
      } elsif ($records->{$id}->{$semanev}->{"created"} ne $records->{$id}->{$semanev}->{"modified"}) {
        print "<td>modified</td>";
      } else {
        print "<td>original</td>";
      }
      print "<tr>";
    }
  }

  print "</table>";

  $db->SQL_disconnect();
  return $records;
}

# feltoltott file feldolgozasa
sub UploadFile {
  my $file = @_[0];
  my ($most_konvertalt_rekordok, $eddigi_oai_rekordok);

  my $sema_format = $query->param('schema');
  my $csvheaderselected = $query->param("csvheader");
  my $sema_xsd = $revmetadataFormats->{$sema_format}->{"schema"};
  my $sema_namespace = $revmetadataFormats->{$sema_format}->{"namespace"};
  my $sema_name = $revmetadataFormats->{$sema_format}->{"format.name"};
  my $map = $revmetadataFormats->{$sema_format}->{"map"};
  my $dcmap = $revmetadataFormats->{$sema_format}->{"dcmap"};

  if (!$sema_format) {
    print "ismeretlen sema!\n";
    return;
  }
  if (((stat $file)[7] > 0) && (open HANDLE, "<$file")) {
    my $sorszam = 0;
    my $mdc, $dc;
    my $identifier;
    if ($csvheaderselected) {
      <HANDLE>;
    }
    while ($line = <HANDLE>) {
      $line =~ s/[\r\n]*$//;
      @data = split($revmetadataFormats->{$sema_format}->{"csvseparator"}, $line);
      $data[0] =~ s/^\357\273\277//; # strip utf8 header
      for ($i = 0; $i <= $#data; $i++) {
        $mdc->{$map->[$i]->[0]}->{$map->[$i]->[1]}->{$map->[$i]->[2]} = $data[$i];
        $dc->{$dcmap->[$i]->[0]}->{$dcmap->[$i]->[0]}->{$dcmap->[$i]->[1]} = $data[$i];
        if (($map->[$i]->[0] eq "identifier") && ($map->[$i]->[1] eq "identifier")) {
          $identifier = $data[$i];
        }
      }
      my $betoltes_datuma = ISO8601Date();
      if ($setneve) {
        $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"sett"} = $setneve;
        #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"sett"} = $setneve;
      } else {
        $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"sett"} = "";
        #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"sett"} = "";
      }
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"created"} = $betoltes_datuma;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"created"} = $betoltes_datuma;
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"modified"} = $betoltes_datuma;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"modified"} = $betoltes_datuma;
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"deleted"} = $betoltes_datuma;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"deleted"} = $betoltes_datuma;
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"xml"} = generateXML($mdc, NULL, $sema_xsd, $sema_namespace, $sema_format);
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"xml"} = generateXML_oai_dc($dc, NULL, $oai_dc_xsd, $oai_dc_namespace, $oai_dc_format);
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"root_name"} = $sema_format;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"root_name"} = $oai_dc_format;
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"root_namespace"} = $sema_namespace;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"root_namespace"} = $oai_dc_namespace;
      $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"externalid"} = $identifier;
      #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"externalid"} = $identifier;
      if (($dc->{"sorce"}) && (length($dc->{"source"}->{"source"}->{"0"}) > 0) &&
        !($dc->{"source"}->{"source"}->{"0"} =~ m@(http|ftp)s?://.*\..*@)) {
        $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"harvestable"} = "n";
        #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"harvestable"} = "n";
      } else {
        $most_konvertalt_rekordok->{$identifier}->{$sema_format}->{"harvestable"} = "y";
        #$most_konvertalt_rekordok->{$identifier}->{"dc"}->{"harvestable"} = "y";
      }

      $sorszam++;
    }
    close HANDLE;
  } else {
    print "Hiba feltlts kzben<br>Lehetsges ok:<ol><li>A feltltsi knyvtrra ($file)nincs rsi joga a webszervernek";
    return;
  }

  if (($eddigi_oai_rekordok = getRecordsNew($repository, 1)) == -1) {
    print "<br />Nem tudom megnyitni az adatbzist!<br />";
    return 0;
  }
  my @tmp = keys %$most_konvertalt_rekordok;

  if (($most_konvertalt_rekordok) && ($#tmp >= 0)) {
    print "<table cellpadding=2 cellspacing=0 border=1><tr><td colspan=2 align=center>Most beolvasott rekordok</td></tr>";
    print "<tr><td>rekord azonosito</td><td>sema</td></tr>";
    foreach $identifier (sort keys %$most_konvertalt_rekordok) {
      foreach $semanev (sort keys %{$most_konvertalt_rekordok->{$identifier}}) {
        print "<tr><td>" . $identifier . "</td><td>" . $semanev . "</td></tr>";
        if ($eddigi_oai_rekordok && ($eddigi_oai_rekordok->{$identifier})) {
          if ($eddigi_oai_rekordok->{$identifier}->{$semanev}) {
            if ($most_konvertalt_rekordok->{$identifier}->{$semanev}->{"xml"} ne $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"xml"} || $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"sett"} ne $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"sett"}) {
              # modosult a rekord tartalma, vagy mas halmazba sorolodott at
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"sett"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"sett"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"xml"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"xml"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"modified"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"modified"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"harvestable"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"harvestable"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_name"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_name"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_namespace"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_namespace"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"externalid"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"externalid"};
            } else {
            }
            if ($eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"} ne $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"}) {
              # ezek szerint korabban toroltuk, most meg megis be akarjuk rakni
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"modified"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"modified"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"harvestable"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"harvestable"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_name"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_name"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_namespace"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_namespace"};
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"externalid"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"externalid"};
            }
          } else {
            # az adott metaadat mar mas formatumban, mas sema szerint rendelkezesre all
            #$t = array_keys($eddigi_oai_rekordok->{$identifier});
            #$id = $eddigi_oai_rekordok->{$identifier}->{$t->{0}}->{"id"};

            #$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"} = $identifier;
            $maxid++;
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"} = $maxid;
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"sett"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"sett"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"created"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"modified"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"modified"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"deleted"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"xml"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"xml"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"harvestable"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"harvestable"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_name"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_name"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_namespace"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_namespace"};
            $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"externalid"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"externalid"};
          }
        } else {
          # nincs meg ilyen rekord azonosito
          #$maxid++;
          #$eddigi_oai_rekordok[$identifier][$semanev]["old_id"] = $maxid;
          $maxid++;
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"} = $maxid;
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"sett"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"sett"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"created"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"modified"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"modified"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"deleted"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"xml"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"xml"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"harvestable"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"harvestable"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_name"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_name"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_namespace"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"root_namespace"};
          $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"externalid"} = $most_konvertalt_rekordok->{$identifier}->{$semanev}->{"externalid"};
        }
      }
    }
    print "</table><br><br>";
  }
  my $records;

  if ($eddigi_oai_rekordok) {
    # torolt elemek beallitasa
    foreach $identifier (keys %$eddigi_oai_rekordok) {
      foreach $semanev (keys %{$eddigi_oai_rekordok->{$identifier}}) {
        if (($semanev ne "dc") && ($semanev eq $sema_format)) {
          if (($mode == 0) && ($most_konvertalt_rekordok)) {
            if ($most_konvertalt_rekordok->{$identifier} && $most_konvertalt_rekordok->{$identifier}->{$semanev}) {
              # vagy valtozatlan, vagy mar kijavitottuk
            } else {
              # ez a rekord torlodott
              $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"} = ISO8601Date();
              #$eddigi_oai_rekordok->{$identifier}->{"dc"}->{"deleted"} = ISO8601Date();
            }
          }
        }
      }
    }
    # recordok osszefesulese
    foreach $identifier (keys %$eddigi_oai_rekordok) {
      foreach $semanev (keys %{$eddigi_oai_rekordok->{$identifier}}) {
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"id"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"sett"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"sett"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"created"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"created"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"modified"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"modified"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"deleted"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"deleted"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"xml"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"xml"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"harvestable"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"harvestable"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"root_name"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_name"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"root_namespace"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"root_namespace"};
        $records->{$eddigi_oai_rekordok->{$identifier}->{$semanev}->{"id"}}->{$semanev}->{"externalid"} = $eddigi_oai_rekordok->{$identifier}->{$semanev}->{"externalid"};
      }
    }
  }

  if ($records) {
    writeRecords($repository, $records, $config->{"repositoryId"});
  }
  return 1;
}

# megnezzuk, hogy feltoltott-e a user valamit es sikeres volt-e a foltoltes, ha igen, atmozgatjuk a feltoltott tmp file-t
# egy altalunk elerheto helyre (sajat directory-ba) - safe_mode restrictions miatt csinaljuk igy (Closes: #000001 ;)))
# ha ez mind sikerult, akkor feldolgozzuk -> UploadFile
sub main {
  #if ($upload_size_max) {
  #  $CGI::POST_MAX = $upload_size_max;
  #}

  #$|=1;

  $query = new CGI;
  $debug = 0;

  $g_title = "File feltlts";
  $g_overwrite = 1;

  print $query->header;

  PrintHeader();

  if ($fh = $query->upload('userfile')) {
    $file = POSIX::tmpnam();
    open(TMPFILE, ">$file");
    while ($line = <$fh>) {
      print TMPFILE $line;
    }
    close(TMPFILE);
    if (UploadFile($file)) {
      triggerHarvester();
    }
    unlink($file);
  } elsif ($fh) {
    print "Nem tudtam feldolgozni a feltoltott file-t (" . $fh . ")<br />\n";
  }

  PrintForm();
  PrintFooter();
}

return 1;
